<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Category API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Point of Sale</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/category/index" class="list-group-item list-group-item-action ">Category</a>
                    <a href="/variant/index" class="list-group-item list-group-item-action ">Variant</a>
                    <a href="/product/index" class="list-group-item list-group-item-action ">Product</a>
                    <a href="/orderheader/index" class="list-group-item list-group-item-action active">Order header</a>
                    <a href="/orderdetail/index" class="list-group-item list-group-item-action">Order detail</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Order Header API</h2>
                        </hr>
                        <h4>Order List</h4>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchOrderHeader(this.value)" autocomplete="off">
                        <div id="dataList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="myModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                </div>
                <div class="modal-body"></div>
            </div>
        </div>
    </div>

    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>
    <script>
        function OpenList(currentPage, length) {
            $.ajax({
                url: '/api/orderheadermapped?page=' + currentPage + '&size=' + length,
                type: 'GET',
                contentType: 'application/json',
                success: function(order) {
                    console.log(order)
                    let table = '<select class="custom-select mt-3" id="size" onchange="OpenList(0,this.value)">'
                    table += '<option value="3" selected>..</option>'
                    table += '<option value="5">5</option>'
                    table += '<option value="10">10</option>'
                    table += '<option value="15">15</option>'
                    table += '</select>'
                    table += "<table class='table table-bordered mt-3'>";
                    table += "<tr> <th>#</th> <th>Reference</th> <th>Amount</th> <th>Action</th> </tr>"

                    if (order.orderHeader.length > 0) {
                        for (let i = 0; i < order.orderHeader.length; i++) {
                            table += "<tr>"
                            table += "<td>" + (i + 1) + "</td>"
                            table += "<td>" + order.orderHeader[i].reference + "</td>"
                            table += "<td>" + order.orderHeader[i].amount + "</td>"
                            table += "<td> <button class='btn btn-sm btn-primary' onclick='GetDetail(" + order.orderHeader[i].id + ")'>Detail</button> </td>"
                            table += "</tr>"
                        }
                    } else {
                        table += "<tr> <td colspan='3' class='text-center'>No Data</td> </tr>"
                    }

                    table += "</table>";
                    table += "<br>"
                    table += '<nav aria-label="Page navigation">';
                    table += '<ul class="pagination">'
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (order.currentPage - 1) + ',' + length + ')">Previous</a></li>'
                    let index = 1;
                    for (let i = 0; i < order.totalPages; i++) {
                        table += '<li class="page-item"><a id="pageslink" class="page-link" onclick="OpenList(' + i + ',' + length + ')">' + index + '</a></li>'
                        index++;
                    }
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (order.currentPage + 1) + ',' + length + ')">Next</a></li>'
                    table += '</ul>'
                    table += '</nav>';
                    $('#dataList').html(table)
                }
            });
        }

        function GetDetail(orderHeaderId) {
            console.log(orderHeaderId)
            $.ajax({
                url: '/api/orderdetailbyorder/' + orderHeaderId,
                type: 'GET',
                contentType: 'application/json',
                success: function(detail) {
                    console.log("detail: ", detail)
                    let table = '<table class="table table-bordered">';
                    table += "<tr> <th>Product Category</th> <th>Variant</th> <th>Name</th> <th>Price</th> <th>Quantity</th> </tr>"
                    if (detail.length > 0) {
                        for (let i = 0; i < detail.length; i++) {
                            table += "<tr>"
                            table += "<td>" + detail[i].product.variant.category.categoryName + "</td>"
                            table += "<td>" + detail[i].product.variant.variantName + "</td>"
                            table += "<td>" + detail[i].product.productName + "</td>"
                            table += "<td>" + detail[i].product.productPrice + "</td>"
                            table += "<td>" + detail[i].quantity + "</td>"
                            table += "</tr>"
                        }
                    } else {
                        table += "<tr>"
                        table += "<td colspan='5' class='text-center'>No Data</td>"
                        table += "</tr>"
                    }
                    table += "</table>";
                    $('.modal-title').html("Order Amount");
                    $('.modal-body').html(table);
                    $('#myModal').modal('show')
                }
            });
        }

        function SearchOrderHeader(request) {
            //console.log(request)

            if (request.length > 0) {
                $.ajax({
                    url: '/api/searchorderheader/' + request,
                    type: 'GET',
                    contentType: 'application/json',
                    success: function(result) {
                        //console.log(result)
                        let table = "<table class='table table-bordered mt-3'>"
                        table += "<tr> <th>#</th> <th>Reference</th> <th>Amount</th> <th>Action</th> </tr>"
                        if (result.length > 0) {
                            for (let i = 0; i < result.length; i++) {
                                table += "<tr>"
                                table += "<td>" + (i + 1) + "</td>"
                                table += "<td>" + result[i].reference + "</td>"
                                table += "<td>" + result[i].amount + "</td>"
                                table += "<td> <button class='btn btn-sm btn-primary' onclick='GetDetail(" + result[i].id + ")'>Detail</button> </td>"
                                table += "</tr>"
                            }
                        } else {
                            table += "<tr>";
                            table += "<td colspan='5' class='text-center'>No data</td>";
                            table += "</tr>";
                        }

                        table += "</table>";
                        $('#dataList').html(table)
                    }
                });
            } else {
                OpenList(0, 5);
            }
        }
    </script>
</body>

</html>